

cgiluamanual = {}

function cgiluamanual.SelectLanguage( tagname, content )
  local l = "portugues"

  if cgi and strfind( cgi.vdir, "/manuals/" ) then
    l = "ingles"
  end
  if tagname == l then return content
  else return "" end
end
    
function cgiluamanual.Sample( tagname, str )
  local opendolar = "$|format('%%c%|', 36 )|$"
  local closedolar = "$|format('%|%%c', 36 )|$"
  str = gsub( str, "<", "&lt;")
  str = gsub( str, ">", "&gt;")
  str = gsub( str, "\n", "&nbsp;&nbsp;\n&nbsp;&nbsp;")
  str = gsub( str, "(&lt;%!%-%-%$%$)", "<font color=#336600>%1" )
  str = gsub( str, "(%$%$%-%-&gt;)", "%1</font>" )
  str = gsub( str, "(%$%|)(.-)(%|%$)", "<font color=#336600>"..opendolar.."%2"..closedolar.."</font>" )
  str = gsub( str, "\n&nbsp;&nbsp;$", "" )
  str = strsub( str, 1, -14 )
  return '<br><table><tr><td bgcolor=#ffffee><pre><code>'..str..'</code></pre></td></tr></table>'
end

cgiluamanual.tags = {
  { tagname="example",  open="", close="", func=cgiluamanual.Sample },
  { tagname="var", open="<code><i>", close="</code></i>" },
  { tagname="codigo", open="<br><table><tr><td bgcolor=#ffffee><pre>", close="<br></td></tr></table>" },
  { tagname="function",  open="<table border=0 cellpadding=0 cellspacing=0>", close="</table><br><hr noshade size=1>" },
  { tagname="description",  open="<tr><td valign=bottom height=10><strong><portugues>Descrio</portugues><ingles>Description</ingles></strong></td></tr><tr><td>", close="</td></tr>" },
  { tagname="parameters",  open="<tr><td valign=bottom height=30><strong><portugues>Parmetros</portugues><ingles>Parameters</ingles></strong></td></tr><tr><td>\n<table width=100%%><tr><td valign=top width=15%%><i>", close="</i></td></tr></table></td></tr>" },
  { tagname="paramdescr", open="</i></td><td>", close="</td></tr>\n<tr><td valign=top width=15%%><i>" },
  { tagname="return",  open="<tr><td valign=bottom height=30><strong><portugues>Retorno</portugues><ingles>Return</ingles></strong></td></tr><tr><td>", close="</td></tr>" },
  { tagname="usage", open="<tr><td valign=bottom height=30><strong><portugues>Exemplo de uso</portugues><ingles>Example of use</ingles></strong></td></tr><tr><td>", close="</td></tr>" },
  { tagname="note",  open="<tr><td valign=bottom height=10><br><strong><portugues>Observaes</portugues><ingles>Notes</ingles></strong></td></tr><tr><td>", close="</td></tr>" },
  { tagname="library", open="<table width=90%% cellpading=0 cellspacing=0>", close="</table>" },
  { tagname="libdescr", open="<tr><td colspan=2>", close="</td></tr><tr><td colspan=2>&nbsp;</td></tr>" },
  { tagname="libauthor", open="<tr><td valign=top width=40%%><i><ingles>Library's author(s)</ingles><portugues></portugues><i>:</td><td>", close="</td></tr>" },
  { tagname="libloaded", open="<tr><td valign=top width=40%%><i><ingles>Loaded by default</ingles><portugues></portugues><i>:</td><td>", close="</td></tr>" },
  { tagname="libref", open="<tr><td colspan=2>&nbsp;</td></tr><tr><td valign=top width=40%%><i><ingles>Reference</ingles><portugues></portugues><i>:</td><td>", close="</td></tr>" },
  { tagname="ingles",  open="", close="", func=cgiluamanual.SelectLanguage },
  { tagname="portugues",  open="", close="", func=cgiluamanual.SelectLanguage },
}

cgilua.custom_tags = cgiluamanual.tags

