$debug

loadlib( 'smtpmail', cgilua.directory )
cgilua.loadlibrary( 'luamail', 'maillib_open' )

function mail_buildheader( tab )
   local addheader
   
   addheader = format( "X-Sender: %s\r\n", "CGILua Mail" )
   addheader = addheader .. format( "Mime-Version: 1.0\r\n" )
   addheader = addheader .. format(	"Content-Type: text/plain; charset=\"iso-8859-1\"\r\n" )

   if type( tab.cc ) == 'string' then
     addheader = addheader .. format(	"Cc: %s\r\n", tab.cc )
   end

   if type( tab.bcc ) == 'string' then
     addheader = addheader .. format(	"Bcc: %s\r\n", tab.bcc )
   end

   local remotehost = getenv( "REMOTE_HOST" )
   local remoteuser = getenv( "REMOTE_USER" )
   local useragent = getenv( "HTTP_USER_AGENT" )

   if remotehost then
     if not remoteuser then remoteuser = "anonymous" end
     addheader = addheader .. format( "X-RemoteUser: %s\r\n", remoteuser .. '@' .. remotehost )
   end

   if useragent then
     addheader = addheader .. format( "X-UserAgent: %s\r\n", useragent )
   end

   addheader = addheader .. "\r\n"

   return addheader
end

function mail( tab )

   if type(tab)~='table' then
     error( "Function parameter must be a table, with mail parameters as table fields" )
   end

   if not tab.to or type(tab.to)~='string' then
     error( "Cannot send mail without the 'to' parameter" )
   end

   local clean = function ( email ) return gsub( email, "%s", "" ) end
   local tolist = cgilua.strsplit( tab.to, ", \t" )
   local cclist = cgilua.strsplit( tab.cc, ", \t" )
   local bcclist = cgilua.strsplit( tab.bcc, ", \t" )
   local recptable = { tolist, cclist, bcclist } 

   local i = 1
   local recp = { n=0 }
   while recptable[i] do
     if recptable[i] then
       local j = 1
       while j <= recptable[i].n do
         local email = clean( recptable[i][j] ); 
         recp.n=recp.n+1
         recp[recp.n]= email
         j = j + 1
       end
       i = i + 1
     end
   end

   local mailserver
   if tab.mailserver then
     mailserver = tab.mailserver
   else
     mailserver = MAILSERVER
   end

   local message = mail_buildheader( tab )
   if type( tab.message ) == 'string' then
     message = message .. tab.message
   end
     
   return syncmail{ mailserver=mailserver, to=recp, from=tab.from, subject=tab.subject, message=message }
end


